Version 5.3 (11/20/2019)
* Fixed issues with the registration dialog where registration would not persist
* Plugins are now notarized to comply with MacOS Catalina changes
* Improved logging, preventing hangups on background logging threads
* Better handling of child processes on Windows

Version 5.2 (5/14/2019)
* Plugin startup and shutdown procedures have been greatly improved.  
* Fixed issues that caused PSOS calls to return "Host capacity exceeded"
* Fixed issues that prevented plugins from autoupdating using the Install Plugin script step
* Fixed an issue where multiple server side scripts would cause plugin functions to time out
* Fixed issues related to multi user environments (Server side scripts, WebDirect, Custom Web Publishing)
* Fixed issues where child processes would not be terminated on shutdown
* Reworked GUI framework, so that plugin windows will stay in lock-step with FileMaker windows
* Better error reporting when running GUI functions and using the EvaluteGroovy function

Version 5.1 (6/14/2018)
* Fixed a problem that caused some plug-ins installed in FMS 17 on Windows to not initialize

Version 5.09 (1/22/2018)
* Fixed a problem where plug-ins that had just been installed on Windows would not initialize if Internet Security options were set to 'high'
* Fixed a bug where generated plug-ins did not work on the server after the first time they are called
* Fixed a bug generating cross-platform plugins from Mac with ScriptMaster Advanced

Version 5.07 (12/6/2017)
* Now compatible with MacOS High Sierra
* License checking code has been improved - fixed several issues related to license checking
* Graphical User Interface (GUI) improvements made to progress bars, file choosers, and configuration dialog windows
* Better reliability when loading and initializing plug-ins

Version 5.05 (6/6/2017)
* Fixed cases where server-side scripts could cause the FileMaker Scripting Engine to hang
* Fixed some issues with FileMaker Cloud when enabling and disabling plug-ins repeatedly
* Fixed some problems on Mac displaying configuration dialog
* Fixed an issue for maintenance customers getting an incorrect message that their license was expired
* Restored compatibility for 32-bit Windows OS

Version 5.04 (5/27/2017)
* Many bug fixes, especially for GUI operations, server-side operations, and running multiple plug-ins

Version 5.03 (5/12/2017)
* Fixed an issue that prevented plug-ins from loading in Windows Server 2012r2
* Fixed an incorrect licensing error when attempting to generate plugins with ScriptMaster Advanced

Version 5.02 (5/11/2017)
* No longer requires Java installation
* Can use plugin functions as script steps with a user-friendly GUI for specifying parameters
* Better error reporting in scripts
* Compatible with FileMaker Cloud
* Better compatibility with FileMaker Server for Perform Script on Server and scheduled scripts
* Each plugin runs in a separate process, increasing reliability and stability
* Plugins can be reliably unloaded, making it possible to auto-update without restarting FileMaker
* Where appropriate, plugin parameters can be selected from pull-down lists and checkboxes
* Support for streaming large container data, allowing unlimited amounts of data to be transferred between FileMaker and the plugin without running out of memory.
* Compatible with the older plugin API, so you can continue to use your existing scripts and calculations with the new plugins.
* Corrected URL for help button in plugin configuration dialog

Version 4.43 (10/5/2015)
* Parameters containing 'noLog' (case insensitive) will not be logged

Version 4.42 (5/21/2015)
* Fixed bug that prevented generated plug-ins from working
* Updated to Groovy version 2.4

Version 4.41 (5/12/2015)
* FileMaker 14 compatibility release
* Updates to usage with PSOS and server scheduled scripts
* Updates to install plugin and auto-update

Version 4.32 (12/15/2014)
* Full support for Perform Script on Server (PSOS), FileMaker Server 13 feature
* 64-bit support for all plugin deployments
* Support for Windows Server 2012
* Various fixes and improvements

Version 4.3 (6/27/2014)
* Support for variable number of arguments in registered functions. Use "..." after the parameter name, and that will be set as a List of Strings.
* Support for optional arguments in registered functions. Use "?" after the parameter name, and it will be flagged as optional.

Version 4.207 (3/13/2014)
* Changed parameter name in Call Script Immediately module

Version 4.206 (1/10/2014)
* Fixed DeleteFileOrFolder module to return true on successful deletion

Version 4.205 (7/24/2013)
* Removed requirement for connection to licensing server from generated ScriptMaster runtimes

Version 4.204 (7/5/2013)
* Now fully supports creating custom 64-bit plugins from Mac and Windows environments
* Updated example files

Version 4.203 (6/27/2013)
* Fixed a problem where plugins generated using ScriptMaster Advanced were not able to run SQL queries on Windows
* Updated documentation for error handling
* Generated plugins now include the SMSetErrorCapture() function, so the developer may choose to suppress error dialogs (See documentation for more information)

Version 4.2 (6/21/2013)
* New error reporting features in plug-in.
* Compatible with Java 7 Update 25
* Fixed example XML in the Validate XML module. There are errors which the module reports successfully based on the schema.
* Now includes Groovy version 2
* 64 bit support
* Now automatically switches to the new FileMaker SQL implementation introduced in FileMaker 11 (still backwards compatible to version 8 using the old SQL implementation)

Version 4.134 (9/11/2012)
* Fixed bug that occurs on Windows when copying and pasting layout elements in FileMaker 12
* Added RSA encryption modules (Key generation, encryption, decryption)
* Added Unzip File module to decompress .zip files

Version 4.132 (4/4/2012)
* FileMaker Pro and Server 12 compatibility release.

Version 4.131 (1/11/2012)
* Updated Groovy to version 1.8.5
* Now includes SMGetVariable function for generated plugins. This makes it easier to return multiple outputs from a ScriptMaster function.
* Fixed a rare bug that could occur when generating custom plugins with ScriptMaster Advanced, if an external jar file had an incorrect size entry
* Fixed an issue that would not allow plugin help text to have umlauts or other international characters.
* Fixed a character encoding problem when using clipboard functions in ScriptMaster with UTF-16 clipboard formats..
* Fixed a problem with example module "Access the FileMaker Calculation Engine Part 3" not being able to run when executed from demo file.

Version 4.124 (4/8/2011)
* Fixed an issue that was preventing modules from being registered on Mac OS 10.5

Version 4.123 (3/18/2011)
* Fixed a bug where custom plugins made by ScriptMaster 4 Advanced would not be properly updated through FileMaker Server Auto-Update.  Auto-Update will only work if the plugin is updated before any of the custom plugin functions are called (other than the version function).

Version 4.122 (2/25/2011)
* Fixed a plugin generation issue introduced in version 4.121.

Version 4.121 (2/23/2011)
* Resolved "Can't start AWT" error some users were receiving in FileMaker Pro and FileMaker Runtime.

Version 4.12 (1/24/2010)
* Fixed issues with Auto-Update on Mac and Windows.  Plugins prior to this version will need to be removed from the Auto-Update directory, we've put together an applet to take care of this http://www.360works.com/remove-plugins/.  Previously, FileMaker needed to be restarted after Auto-Update on Mac and on Windows the update had to be performed manually in some cases, this update takes care of both issues.

Version 4.11 (1/19/2011)
* Late-breaking Windows clipboard fix reported by Matt Petrowsky

Version 4.1 (1/18/2011)
Improvements:
* Now has Groovy 1.7.6 compiled into the plugin.
* SQL statements no longer appear in plugin log files (unless an error occurs; errors are always logged with all parameters).
* Plugins generated with ScriptMaster Advanced now have a registration.txt file included in the output with the license key

Bug fixes:
* Fixed a bug where clipboard functions did not work in Windows
* Modified 'Get URL As Text' module to detect character encoding, instead of assuming utf-8.
* Rewrote Shell script module; added an option to run in background; should be much more reliable and work as expected on Mac and Windows.
* Fixed a problem when running multiple 360Works plugins on Windows Server 2008 R2 / Windows 7
* Plugins generated with ScriptMaster Advanced that included 3rd party jar files were crashing in Windows; this is fixed.

Version 4.02 (8/3/2010)
* Fixed a bug where copying registration function onto clipboard did not work

Version 4.01 (7/28/2010)
* FMPro.setClipboardContents now has an optional clearExisting boolean flag
* Windows-specific fix to always set clipboard format #2, which is needed for pasting layouts.

Version 4.0 (7/20/2010)
=== Major changes ===
* You can optionally specify a module as a non-GUI function. Our benchmark testing shows that this increases execution of simple modules from 300 times per second to 3,000 times per second!
* You can now load ScriptMaster modules from a network URL using the SMLoadJar function, which lets you centralize all of your favorite modules onto a web server and load them into your solution.
* Major speed improvements to compiling ScriptMaster functions.
* Now has Groovy 1.7.1 compiled into the plugin. This supports many new groovy features, such as the GroovyWS web services classes.

=== New modules ===
* Added an 'XPath Parsing' module
* Added 'Notify Prowl' module for sending push notifications to iPhone / iPad (Thanks Todd Geist).
* Added a 'Move Or Rename File' module (Thanks Jack James)
* Added a 'Get Folder Size' module for recursively determining the size of a folder
* Added a 'Find Images URL' module for finding all image URL references in an HTML page

=== ScriptMaster Advanced ===
You may now choose to purchase ScriptMaster Advanced Edition. The Advanced edition has these features in addition to what comes with the free version:
* You can create your own FileMaker plugins from ScriptMaster, which can be distributed royalty-free to any client with your FileMaker solution. You can name them whatever you want, and they will have your favorite ScriptMaster modules embedded right into the plugin!
* You can execute SQL statements in FileMaker with the Advanced Edition, or with plugins generated from it
* You can read and write from the system clipboard with the Advanced Edition, or with plugins generated from it
* Plugins generated from the Advanced Edition are pre-compiled, so they do not need to be compiled at startup. This will greatly improve solution launch times.

=== Other changes ===
* Stability improvements, fixed many cases where FileMaker was hanging or flashing when using ScriptMaster in calculation fields.
* Added an 'isDestResidential' true or false flag to FedEx shipping module
* Simplified color chooser module
* Minor bug fix on Tree View example so that it would not pop up an extra window
* Better international character handling for these modules: Read File Contents, Run Shell Script, Post XML Data
* Read File Contents can now read a file of unlimited size without running out of memory
* Removed the 'download URL' field in the ScriptMaster file; it is no longer used.

Version 3.33 (3/8/2010)
* Fixed intermittent problem where plugins may not load in Windows XP in FileMaker 11

Version 3.32 (2/25/2010)
* Fixed potential crashing issues in OS X 10.5
* FedEx modules now have a 'testMode' parameter that can be set to 'true' or 'false' for switching between test and live mode.
* Improved parameter names in screen capture module
* Send e-mail modules now support utf-8 encoding

Version 3.31 (2/4/2010)
* Removed error dialog popups added in last update
* Stability improvements
* Fixed bugs that could potentially cause crashes in some situations

Version 3.301 (1/27/2010)
* Now displays visible error message unless SetErrorCapture is on
* Fixed situations where modal dialogs could appear behind other windows in  MS Windows
* Fixed plugin not loading in Java 6 update 18

Version 3.22 (10/30/2009)
* Minor change to Send Email modules to support international characters
* Minor bug fix in Zip File module

Version 3.21 (9/23/2009)
* Changed Run Shell Script module to support commands line arguments with spaces in file name (most be wrapped in quotes)

Version 3.2 (9/8/2009)
* Added convertPathToFileMaker method to FMPro object to help convert file paths to FileMaker-specific format

Version 3.1 (8/27/2009)
* OS X 10.6 Snow Leopard compatible
Added new modules:
* CreateFolder - creates a folder, including all of its subfolders.
* DeleteFolderOrFile - deletes a folder or file. Recursive deletes for folders, so be careful!
* Get Url As Text now correctly supports utf-8 international web pages

Version 3.0 (6/9/2009)
ScriptMaster 3 has an entirely re-designed user interface, BIG thanks to Matt Petrowsky at http://www.filemakermagazine.com/
There is now a video tutorial that shows how to use ScriptMaster: http://www.youtube.com/watch?v=9vN1CDA4f40

Several new modules have been added to ScriptMaster:
=== Text ===
* Validate XML - Does a syntax check on an XML text to see whether it is well-formed.
* URLDecode - the companion to FileMaker's built-in GetAsURLEncoded function
=== Containers ===
* Crop Image - crop an image to specified coordinates
* Watermark Image - apply a text watermark to an image
=== File System ===
* List All Files Recursively - Lists all files in a directory, including subdirectories
* Get File Size - Gets the size, in bytes, of a file on disk
* Get File Modification Date - Gets the date that a file was modified
* Zip File - create a .zip archive of a file or directory
* Choose Folder - presents a folder selection dialog
=== Number crunching===
* Create AES Secret Key - this generates a secure key that can be used with the next 2 functions.
* EncryptAES / DecryptAES - These use the Rijndael AES encryption algorithm (http://en.wikipedia.org/wiki/Advanced_Encryption_Standard) to encrypt data. In June 2003, the US Government announced that AES may be used to protect classified information.
* Better Random - gets around issues with FileMaker's built-in random number generator
===GUI===
* Popup Menu - has now been modified to take a return-separated list of menu choices; returns the user's choice as the function result.
* QuickTime Frame Capture - capture a snapshot from an iSight or any other QuickTime-compatible video input

Version 2.08 (2/10/2009)
* Fix for multiple users running ScriptMaster on the same machine

Version 2.07 (2/1/2009)
* Added a new feature to return any InputStream as a container to FileMaker. See the 'Get Container from InputStream' module in the developer file for an example.

Version 2.06 (1/28/2009)
* Fixed compatibility issues with running on Server 10 and IWP

Version 2.05b (12/22/2008)
* Fixed a build error that prevented ScriptMaster from working in Tiger (OS X 10.4.x)

Version 2.05a (12/3/2008)
* Now logs plugin parameters in the event of a code execution failure to make it easier to troubleshoot problems

Version 2.05 (11/17/2008)
* Fixed crash when passing very large strings (> 1M characters) while running in IWP.

Version 2.04 (11/13/2008)
* Fix for applets when using Java 1.6_10

Version 2.03 (10/14/2008)
* Added a new module, 'Text similarity', that rates how closely two text items match. Very useful for finding near-duplicates. Thanks to Matt Navarre for the suggestion.
* Added keyboard shortcuts to color chooser dialog module

Version 2.03 (8/15/2008)
* Fixed a bug on OS X where running 2 copies of FileMaker with ScriptMaster installed would crash

Version 2.02 (8/12/2008)
* Fixed a bug where calling scripts in FileMaker would sometimes not work from registered functions

Version 2.01 (7/30/2008)
* Added 'Post XML Data' module

Version 2.0 (7/1/2008)
* Added the ability to register modules as filemaker functions
* Many improvements to development file
* Much faster execution for modules registered as functions

Version 1.66 (4/18/2008)
* Returning a RenderedImage encodes the image as a PNG instead of a JPG, resulting in much nicer images.
* Better support for copying scripts from the demo file for graphic files

Version 1.651 (2/21/2008)
* Critical fix in bundled groovy version
* Corrected some cases where line breaks on windows were duplicated when returning values to FileMaker.

Version 1.64
* Upgraded to the latest Groovy version (1.5.4)

Version 1.63
* Licensing changes - now allows redistribution

Version 1.6
* Better support for getting URL contents where the URL doesn't specify a file extension (google charts, for example)

Version 1.52
* Fixed bug in fmpro.performScript (it now requires a filename as the first parameter, and is more stable)
* Fixed some bugs in the example file scripts 

Version 1.4
* Better GUI stability and modal dialog support
* Groovy images auto-convert to FileMaker containers
* Fixed bug with demo license keys

Version 1.3
* Improved stability (upgraded to groovy version 1.0)
* Passing "eval-style" (table::field) parameters works on mac & windows

Version 1.2
* Container support implemented
* Better handling of containers as references
